#NoTrayIcon

#include <GUIConstantsEx.au3>
#include 'AutoItErrorHandler.au3'

If Not _OnAutoItErrorRegister('', '', 'My App Error') Then
	Switch @error
		Case -1
			;If Not @Compiled Then
				MsgBox(48, @ScriptName, 'ATM, only compiled script is supported, please compile the script.')
			;EndIf
		Case 1
			;If Not StringRegExp(@AutoItVersion, '^3\.3\.(12\.0|9\.4|8\.\d+|6\.\d+)$') Then
				MsgBox(48, @ScriptName, 'ATM, only these AutoIt versions are supported:' & @CRLF & '3.3.12.0 / 3.3.9.4 / 3.3.8.X / 3.3.6.X')
			;EndIf
	EndSwitch
	
	Exit
EndIf

GUICreate('AutoItErrorHandler Example', 350, 200)

GUICtrlCreateLabel('This script is just an example.' & @LF & @LF & 'It will produce a syntax error in', 25, 40, 300, 50)
GUICtrlCreateLabel('5', 185, 50, 50, 40)
GUICtrlSetColor(-1, 0xF20000)
GUICtrlSetFont(-1, 30, 800, 0, 'Tahoma')
GUICtrlCreateLabel('seconds.', 220, 67, 300, 50)
GUICtrlCreateLabel('The result shown as a CUSTOM error message, you can change it!', 25, 120, 350, 20)
$iUnRegister_Bttn = GUICtrlCreateButton('UnRegister AutoItError handler', 25, 140, 200, 22)
GUICtrlCreateLabel('Copyright Firex & G.Sandler  2015', 25, 170, 350, 80)
GUICtrlSetColor(-1, 0x808080)
GUICtrlSetFont(-1, 8.5, 800, 6)

GUISetState()

Dim $iTimer

For $i = 3 To 1 Step -1
	GUICtrlSetData(4, $i)
	
	$iTimer = TimerInit()
	
	While TimerDiff($iTimer) < 1000
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				Exit
			Case $iUnRegister_Bttn
				_OnAutoItErrorUnRegister()
		EndSwitch
	WEnd
Next

;We deliberately make a syntax mistake and call the error!
If Random(1, 5, 1) = 3 Then
	MsgBox(0, '', )
Else
	_NotExistingFunc()
EndIf
